@use '../../../stylesheets/core';

/**
 * $name:  The variant name
 * $color: The color name
 *
 * The color should have corresponding CSS variables:
 *    --state-color-<color>
 *    --state-color-<color>-alt
 */
@mixin variant($name, $color) {
  &.rui-timeout-button--#{$name} {
    background-color: var(--state-color-#{$color}-alt);

    .rui-timeout-button__background {
      background-color: var(--state-color-#{$color});
    }

    .rui-timeout-button__label {
      color: var(--state-color-#{$color}-alt);
    }
  }
}

.rui-timeout-button {
  position: relative;

  &__background {
    position: absolute;
    z-index: 0;
    top: 0;
    bottom: 0;
    left: 0;
    border-radius: inherit;

    &--decreasing {
      border-bottom-right-radius: 0;
      border-top-right-radius: 0;
    }
  }

  &__label {
    position: relative;
    z-index: 1;
    display: flex;
    overflow: hidden;
    align-items: center;
    content: '';
    text-overflow: ellipsis;
    white-space: nowrap;
  }

  &--no-text-on-small {
    @include core.respond-to('small') {
      .rui-timeout-button__label__text {
        @include core.sr-only();
      }
    }
  }

  @include variant('destructive', 'red');
  @include variant('creative', 'blue');
  @include variant('recording', 'green');
  @include variant('canceling', 'orange');
}
